; # Dialog
dialog lv {
  title " "
  size -1 -1 197 115
  option dbu
  menu "&", 1
  item " ", 2, 1
  item "&", 19, 1
  item break, 3, 1
  item "&", 4, 1

  box "", 5, 2 1 85 111
  list 6, 6 9 77 100, size

  box "", 9, 121 1 72 111
  list 10, 125 9 64 100, size

  button "&", 12, 89 9 30 11
  button "&", 11, 89 21 30 11
  button "&", 18, 89 33 30 11

  box "", 13, 87 50 34 4
  check "&", 14, 89 60 30 11, push
  check "&", 15, 89 72 30 11, push
  check "&", 16, 89 84 30 11, push
  check "&", 17, 89 96 30 11, push
  button "",120, 0 0 0 0,cancel
}


; # On Dialog Open
on *:dialog:lv:init:*:{
  mdx SetMircVersion $version
  mdx MarkDialog lv
  mdx SetControlMDX lv 6 TreeView haslines hasbuttons showsel linesatroot > $vdll
  if (!%logv.dir) set %logv.dir $$sdir($logdir,Log Directory)
  if (!%logv.colors) set %logv.colors on
  if (!%logv.bold) set %logv.bold on
  if (!%logv.underline) set %logv.underline on
  if (!%logv.reverse) set %logv.reverse on
  load.logs
}


; # On Dialog Single Click
on *:dialog:lv:sclick:6:{
  var %w @LogList,%w2 @C-LogList,%w3 @P-LogList
  tokenize 32 $gettok($did(6,1),1-,32)
  var %s = $branch(lv,6)
  if ( (!%s) || (%s == Channels) || (%s == Queries) ) { return }

  ; Channels
  if $4 == 2 {
    var %s = $branch(lv,6)
    if ( (!%s) || (%s == Channels) ) { return }
    var %i = $fline(%w,$+(%s,*),1),%f = $line(%w,%i)
    window -hs %w2
    ; If line begins with # (^ in regex is beginning)
    if $regex(%f,^#) {
      var %n = $+(",%logv.dir,%f,.log")
      did -ra lv 9 $gettok(%f,1,32)
      ; -f Identifies %n is a file
      ; Inserts everything beginning with Session Start:
      filter -f %n %w2 Session Start:*

      var %x = 1
      did -r lv 10
      while %x <= $line(%w2,0) {
        var %a = $remove($gettok($line(%w2,%x),3-,32),$asctime(yyyy)),%b = $calc($len(%a) - $calc($count(%a,:) + 1))
        did -a lv 10 $left(%a,%b)
        inc %x
      }
    }
    window -c %w2
  }
  ; Queries
  if $4 == 3 {
    var %i = $line(%w,0)
    window -hs %w3
    if ( (!%s) || (%s == Queries) ) { return }
    var %i = $fline(%w,$+(%s,*),1),%f = $line(%w,%i)
    window -hs %w2
    if %f {
      var %n = $+(",%logv.dir,$gettok(%f,1,32),.log")
      did -ra lv 9 $gettok(%f,1,32)
      ; 'ditto' as in Channels with different window
      filter -f %n %w3 Session Start:*

      var %x = 1
      did -r lv 10
      while %x <= $line(%w3,0) {
        did -a lv 10 $remove($gettok($line(%w3,%x),3-,32),$asctime(yyyy))
        inc %x
      }
      window -c %w3
    }
  }
}

; Edit Log
on *:dialog:lv:sclick:11:run $+(",%logv.dir,$did(9),.log")

; View Log
on *:dialog:lv:sclick:12:view-log

; Color On/Off
on *:dialog:lv:sclick:14:set %logv.color $iif($did(14).state,on,off)

; Bold On/Off
on *:dialog:lv:sclick:15:set %logv.bold $iif($did(15).state,on,off)

; Underline On/Off
on *:dialog:lv:sclick:16:set %logv.underline $iif($did(16).state,on,off)

; Reverse On/Off
on *:dialog:lv:sclick:17:set %logv.reverse $iif($did(17).state,on,off)

; Delete Log
on *:dialog:lv:sclick:18:{
  if $input(Are you sure you want to delete: $crlf $+($did(9),?)) {
    .remove $+(",%logv.dir,$did(9),.log")
    if ($dialog(lv)) dialog -x lv lv
    .timer -m 1 1 log-v
  }
}


; # On Dialog Double Click
on *:dialog:lv:dclick:10:view-log

; # On Menu Select
on *:dialog:lv:menu:*:{
  if $did == 2 {
    var %x = $$sdir($logdir,Log Directory)
    set %logv.dir %x
    did -r lv 6,9,10
    did -ra lv 2 %logv.dir
    load.logs
  }
  if ($did == 19) lvhelp
  if ($did == 4) dialog -x lv lv
}

; # On Dialog Close
on *:dialog:lv:close:*:lclose


; # Private Aliases

; mdx command
alias -l mdx dll $+(",$scriptdirmdx.dll,") $1-

; views.mdx path
alias -l vdll return $scriptdir $+ views.mdx

; Loads logs in dialog
alias -l load.logs {
  did -r lv 6,9,10
  lclose
  var %i 1,%w @LogList,%a 1,%b 1
  window -hs %w
  var %m = $findfile(%logv.dir,*.log,0,aline %w $nopath($remove($1-,.log)))
  did -a lv 6 +eb Channels
  did -i lv 6 1 cb 2
  ; -o Incerts in dialog
  ; Inserts everything beginning with #
  filter -o %w lv 6 #*
  did -i lv 6 1 cb root 1
  did -a lv 6 +eb Queries
  did -i lv 6 1 cb 3
  ; -x Excludes anything beginning with #
  filter -ox %w lv 6 #*
  did -i lv 6 1 cb root 1

  if (%logv.colors == on) did -c lv 14
  if (%logv.bold == on) did -c lv 15
  if (%logv.underline == on) did -c lv 16
  if (%logv.reverse == on) did -c lv 17
}

; Views Log
alias -l view-log {
  var %f = $did(lv,9)
  ; %b -- Finds line where the selected time is.
  ; %l -- $readn is the line of above, added by 2 in order to speed process of viewing up,
  ;             by not replaceing, rather inserting.
  ; %w -- Window name of file in order to open multiple windows of logs.
  var %n = $+(",%logv.dir,%f,.log"),%b = $read(%n,w,Session Start: $did(lv,10,$did(lv,10).sel) $+ *),%a,%l = $readn + 2
  var %s = $+($iif(%logv.color == off,c),$iif(%logv.bold == off,b),$iif(%logv.underline == off,u),$iif(%logv.reverse == off,r))
  var %w = $+(@,%f,-,$replace($did(10).seltext,$chr(32),_)),%c = aline -ph %w
  if ($window(%w)) window -c %w
  window -k %w
  %c  $+ $iif($regex(%f,^#),Channel Name:,Query Name:) $gettok(%f,1- $+ $count(%f,.),46) $&
    at $gettok(%f,$calc($count(%f,.) +1) $+ -,46)
  while %l <= $lines(%n) {
    if (Session Close: isin $read(%n,n,%l)) break
    %a = $read(%n,n,%l)
    if ($+(%logv.colors,%logv.bold,%logv.underline,%logv.reverse) == onononon) %c %a
    else %c $strip(%a, [ %s ] )
    inc %l
  }
}

; Log window close
alias -l lclose if ($window(@LogList)) window -c @LogList

;###################################
; $branch made by: Morphy
;     I (Sabby) did NOT code this snippet, I retrieved it off of mircscripts.org
;     Morphy has given me permission to use _his_ snippet in _my_ Log Viewer
;     If this code is being review by the mircscripts.org staff,
;          I'm sure Morphy will clearify that he has given me permission for this code.
alias branch {
  var %d = $1
  var %i = $2
  if ($dialog(%d)) {
    var %b = $gettok($did(%d,%i,1),4-,32)
    var %n = $calc($numtok(%b,32) -1)
    if (%n = 0) did -i %d %i 1 cb root
    else { did -i %d %i 1 cb root $gettok(%b,1- $+ %n,32) }
    return $gettok($gettok($did(%d,%i,$gettok(%b,-1,32)),7-,32),1,9)
  }
}
;###################################


; # Public Aliases
alias log-v dialog $iif($dialog(lv),-vie,-md) lv lv
alias lvhelp {
  var %w = @Log_Viewer_Help,%c = aline -p %w,%s = $str($chr(160),5)
  if ($window(%w)) window -c %w
  window -akdC -t3 +l %w -1 -1 620 280
  %c %s
  %c Log Viewer v3.5 Help
  %c %s
  %c $chr(9) Buttons
  %c $chr(9) %s View Log - Opens log via window
  %c $chr(9) %s Edit Log - Opens log in notepad so you may edit it
  %c $chr(9) %s Del Log - Deletes the selected log with your conformation
  %c $chr(9) Filters
  %c $chr(9) %s Colors - When pressed allows colors in log, when not pressed filters out colors
  %c $chr(9) %s Bold - When pressed allows bolds in log, when not pressed filters out bolds
  %c $chr(9) %s Underline - When pressed allows underlines in log, when not pressed filters out underlines
  %c $chr(9) %s Reverse - When pressed allows reverses in log, when not pressed filters out reverses
  %c $chr(9) Treeview
  %c $chr(9) %s Format - Seperates channels and queries,
  %c $chr(9) %s $+ %s #Channel.Server --- Nickname.Server
  %c $chr(9) Time Format
  %c $chr(9) %s Allows you to select the different times during the log.
  %c %s
}

; # Popups
menu menubar {
   
  .:log-v
